/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// coverbehavior.cpp Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#include "coverbehavior.h"
#include "runaction.h"

CoverBehavior::CoverBehavior(const WorldModel &_wmWorld) : perCover(_wmWorld)
{
}

CoverBehavior::~CoverBehavior()
{
}

bool CoverBehavior::isUseful()
{
  if (perCover.tooFarUp ()) {
    return true;
  } else
    {
      return false;
    }
  /*
  
  if (!perCover.isActiveMode())
    return false;
  
  return (perCover.getPossession() != PS_OURS);
  */
}

void CoverBehavior::evaluate(RecommendationList& recList)
{
  Recommendation recFinal;
  recFinal.szBehaviorName = "coverbogus";
  
  RunAction raRun;
  raRun.setDirection(perCover.relPos(Vector2d(-0.5 * FIELD_LENGTH, 0)).getAngle());
  raRun.setIntensity (60);
  recFinal.addAction (raRun);	
  recFinal.setGrade (90);
  recList.insert (recFinal);

  /*
	Recommendation rCoverRec;
	rCoverRec.szBehaviorName = "cover";
	
	//get the player to cover
	WorldPlayer* wpCoverPlayer = perCover.getCoverPlayer();

	//make sure you aren't already there or there is nobody
	if ( wpCoverPlayer == NULL )
		return;
	
	Vector2d vDist = perCover.relPos(*wpCoverPlayer);	
	
	if (perCover.inDefensiveThird(perCover.getBall()))
		rCoverRec.setGrade(69.1415);
	else
		rCoverRec.setGrade(45);
		
	//get angle and set run action
	if ( norm (vDist) < 2.0 )
	  {
	    if (perCover.onGoalSide(*wpCoverPlayer))
	      {
		RunAction ra;
		ra.setIntensity(0);
		ra.setDirection(0);
		rCoverRec.addAction(ra);
		recList.insert(rCoverRec);
		return;
	      }
	    else
	      {
		RunAction raTemp;
		raTemp.setDirection(PI - perCover.getBodyDir());
		raTemp.setIntensity(30);
		rCoverRec.addAction(raTemp);
		recList.insert(rCoverRec);
	      }
	  }
		
	Angle aDir = vDist.getAngle();


	RunAction raTemp;
	raTemp.setDirection(aDir);
	
	if ( norm (vDist) < 10.0 )
		raTemp.setIntensity(45);
	else
		raTemp.setIntensity(60);
	
	rCoverRec.addAction(raTemp);
	raTemp.setDirection(0);
	rCoverRec.addAction(raTemp);	
	
	recList.insert(rCoverRec);
  */
}








