/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// GoalKickStallperception.h Mon Jul 2 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _GOALKICKSTALLPERCEPTION_H_
#define _GOALKICKSTALLPERCEPTION_H_

#include "perception.h"
#include "angle.h"


class GoalKickStallPerception : public Perception
{
public: 
	GoalKickStallPerception(const WorldModel &_wmWorld);
	virtual ~GoalKickStallPerception();
	int getTime() const;
	bool isGoalKickMode () const;
};

#endif
