/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// turnaction.h Thu Jun 21 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _TURNACTION_H_
#define _TURNACTION_H_

#include "action.h"


class TurnAction : public Action
{
public: 
	TurnAction();
	TurnAction(const Angle &_aDirection);
	virtual ~TurnAction();
	virtual ServerCommand* translate() const;
	virtual Action* copy() const;
	void setDirection(const Angle &_aDirection);
	
	Angle getDirection() const;

    virtual ostream& ostream_insert(ostream& _out) const;
    virtual ofstream& ofstream_insert(ofstream& _fout) const;
	
private:
	Angle aDirection;	
};

#endif
