/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// servercommand.h Fri Jun 22 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _SERVERCOMMAND_H_
#define _SERVERCOMMAND_H_

#include "comm.h"

class ServerCommand
{
public: 
	ServerCommand(const int _iDuration);
	virtual ~ServerCommand();
	virtual Comm& comm_insert(Comm &_cmConnection) const;
	
	virtual bool isTurn () { return false; }
	
	float getDuration() const
	{ return iDuration; }

private:
	const int iDuration;
};

Comm& operator<<(Comm &_cmConnection, const ServerCommand &scCmd);
#endif
