/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// cornerkickperception.h Sat Aug 4 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef CORNERKICKPERCEPTION_H
#define CORNERKICKPERCEPTION_H

#include "perception.h"

class CornerKickPerception : public Perception  {
public: 
  CornerKickPerception(const WorldModel& _wmWorld);
  virtual ~CornerKickPerception();
  bool isActiveMode () const; 
  bool inPosition () const;
  Angle getRunAngle() const;
  int getStamina() const { return (int)wmWorld.getClientPlayer().getStamina(); }
};

#endif
