/////////////////////////////////////////////////////////////////////
// UVA TeamName RoboCup agent developed for the Simulator
// League of the RoboCup 2001 competition.
//
// This team based on the Mainz Rolling Brains RoboCup team from
// the 2000 competition.
//
// Copyright (C) 2001 Team Members
// of the UVA TeamName RoboCup Team.
//
// This program under the terms of the GNU General Public License as
// published by the Free Software Foundation; version 2 of the
// License. See the README file in the root directory of our archive.
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// shootperception.h Tue Jul 3 2001
// Description:
//////////////////////////////////////////////////////////////////////

#ifndef _SHOOTPERCEPTION_H_
#define _SHOOTPERCEPTION_H_

#include "perception.h"

#define GOAL_RANGE 23

class ShootPerception : public Perception
{
public: 
	ShootPerception(const WorldModel &_wmWorld);
	virtual ~ShootPerception();
	bool atBall() const;
	bool atGoal() const;
	double haveShot() const;
	Angle getShotAngle() const;
};

#endif
